module EventMachine
  module Zipper
    class Chunks
      include EventMachine::Deferrable

      attr_reader :file_path, :q

      def initialize(file_path)
        @file_path = file_path
        @q         = EM::Queue.new
      end

      def chop!
        _chunk_method = file_path.match(/\Ahttps?:\/\//) ? :chunk_http : :chunk_file
        __send__ _chunk_method

        self
      end


      private

      def chunk_file
        file = File.open file_path

        fr = proc do
          begin
            q.push file.read_nonblock(16384)
            EM.next_tick(&fr)
          rescue EOFError
            file.close
            succeed(q)
          end
        end

        EM.next_tick(&fr)
      end

      def chunk_http
        http = EventMachine::HttpRequest.new(file_path).get
        http.errback  { fail }
        http.callback { succeed(q) }
        http.stream   { |chunk| q.push chunk }
      end
    end
  end
end
