module EventMachine
  module Zipper
    class Entry
      include EventMachine::Deferrable

      attr_reader :file_path, :chunks, :out

      def initialize(file_path, chunks, out)
        @file_path = file_path
        @chunks    = chunks
        @out       = out
      end

      def write!
        create_entry
        EM.next_tick { chunks.pop(&write_chunks) }

        self
      end


      private

      def write_chunks
        proc do |chunk|
          out << chunk

          if chunks.empty?
            EM.next_tick { succeed }
          else
            EM.next_tick { chunks.pop(&write_chunks) }
          end
        end
      end

      def file_name
        @file_namem ||= File.basename file_path
      end

      def create_entry
        new_entry = ::Zip::ZipEntry.new '-', file_name
        out.put_next_entry(new_entry)
      end
    end
  end
end
