# Provides an IO for http streaming
#
module EventMachine
  module Zipper
    class StreamIO
      include EventMachine::Deferrable

      def initialize(&block)
        @block = block
        @pos   = 0
      end

      def tell
        @pos
      end

      def pos
        @pos
      end


      def <<(x)
        @block.call(x.to_s)
        @pos += x.to_s.bytesize
      end

      def each(&block)
        @block = block
      end
    end
  end
end
